<template>
    <div class="edit-view">
        <el-form
            :model="formData"
            :rules="rules"
            ref="form"
            label-width="66px"
            label-position="right"
            size="small"
            style="max-width: 500px;"
        >
            <el-form-item prop="套餐" label="packageId">
                <el-input-number type="number" v-model="formData.packageId"></el-input-number>
            </el-form-item>
            <el-form-item prop="goodsInfoId" label="名称">
                <el-select v-model="formData.goodsInfoId" filterable @change="optionChange">
                    <el-option v-for="item in goodsList" :key="item.id" :label="item.name" :value="item.id"></el-option>
                </el-select>
            </el-form-item>
            <!--<el-form-item prop="name" label="名称">
                <el-input v-model="formData.name"></el-input>
            </el-form-item>-->
            <el-form-item prop="num" label="数量">
                <el-input-number type="number" v-model="formData.num"></el-input-number>
            </el-form-item>
            <el-form-item prop="unit" label="单位">
                <el-input v-model="formData.unit"></el-input>
            </el-form-item>
            <el-form-item prop="price" label="价格">
                <el-input-number type="number" v-model="formData.price"></el-input-number>
            </el-form-item>
            <el-form-item prop="remark" label="备注">
                <el-input v-model="formData.remark"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving" type="danger" v-if="formData.id">删除 </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'PackageGoodsEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('packageGoods/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
        this.$http
            .post('goodsInfo/allList')
            .then(res => {
                this.goodsList = res;
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                goodsInfoId: [
                    {
                        required: true,
                        message: '请选择商品',
                        trigger: 'blur'
                    }
                ],
                num: [
                    {
                        required: true,
                        message: '请输入数量',
                        trigger: 'blur'
                    }
                ],
                unit: [
                    {
                        required: true,
                        message: '请输入单位',
                        trigger: 'blur'
                    }
                ]
            },
            goodsList: [],
            goods: {}
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };
            data.name = this.goods.name;

            this.saving = true;
            this.$http
                .post('/packageGoods/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/packageGoods/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                });
        },
        optionChange(id) {
            this.goods = this.goodsList.find(item => {
                return item.id === id;
            });
        }
    }
};
</script>
<style lang="less" scoped></style>
